﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.DataContext = ChartData.GenerateData(10);
        }

        private bool isEditing = false;
        private void dataGrid_CellEnteredEditMode(object sender, Infragistics.Controls.Grids.EditingCellEventArgs e)
        {
            isEditing = true;
            var textBox = e.Editor as TextBox;
            if (e.Cell.Tag != null && textBox != null)
            {
                textBox.Text = e.Cell.Tag.ToString();
                e.Cell.Tag = null;

                System.Threading.ThreadPool.QueueUserWorkItem(x =>
                {
                    System.Threading.Thread.Sleep(50);

                    Dispatcher.BeginInvoke(() =>
                    {
                        textBox.Focus();
                        textBox.Select(1, 0);
                        textBox.Focus();
                    });
                });
            }
        }

        private static bool IsNavigationKey(KeyEventArgs e)
        {
            return new[] { Key.Delete, Key.Escape, Key.Enter, Key.Down, Key.Up, Key.Left, Key.Right, Key.Tab, Key.Shift, Key.Ctrl, Key.Alt }.Contains(e.Key);
        }

        private void dataGrid_KeyDown(object sender, KeyEventArgs e)
        {
            if (!isEditing && !IsNavigationKey(e) && dataGrid.ActiveCell.IsEditable)
            {
                bool isShifty = ((Keyboard.Modifiers & ModifierKeys.Shift) == ModifierKeys.Shift);
                string letter = ((char)e.PlatformKeyCode).ToString();
                letter = (isShifty ? letter.ToUpper() : letter.ToLower());

                dataGrid.ActiveCell.Tag = letter;
                dataGrid.EnterEditMode(dataGrid.ActiveCell);
            }
        }

        private void dataGrid_CellExitedEditMode(object sender, Infragistics.Controls.Grids.CellExitedEditingEventArgs e)
        {
            isEditing = false;
        }
    }

    
    public class ChartData
    {
        public int Index { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }

        public static ObservableCollection<ChartData> GenerateData(int count)
        {
            ObservableCollection<ChartData> data = new ObservableCollection<ChartData>();

            Random r = new Random();

            ChartData data0 = new ChartData
            {
                Index = 0,
                Value1 = r.Next(20, 40),
                Value2 = r.Next(20, 40),
                Value3 = r.Next(20, 40),
            };

            data.Add(data0);

            for (int i = 1; i < count; i++)
            {
                ChartData dat = new ChartData
                {
                    Index = i,
                };

                if (r.NextDouble() > .5)
                {
                    dat.Value1 = data[i - 1].Value1 + r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 + r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 + r.NextDouble();
                }
                else
                {
                    dat.Value1 = data[i - 1].Value1 - r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 - r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 - r.NextDouble();
                }

                data.Add(dat);
            }

            return data;
        }
    }				
}
